<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AcceptanceReport StructType
 * @subpackage Structs
 */
class AcceptanceReport extends AbstractStructBase
{
    /**
     * The date
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $date;
    /**
     * The reportIDImport
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $reportIDImport;
    /**
     * The ordersTable
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfOrdersTableRow
     */
    public $ordersTable;
    /**
     * Constructor method for AcceptanceReport
     * @uses AcceptanceReport::setDate()
     * @uses AcceptanceReport::setReportIDImport()
     * @uses AcceptanceReport::setOrdersTable()
     * @param string $date
     * @param string $reportIDImport
     * @param \ArrayType\ArrayOfOrdersTableRow $ordersTable
     */
    public function __construct($date = null, $reportIDImport = null, \ArrayType\ArrayOfOrdersTableRow $ordersTable = null)
    {
        $this
            ->setDate($date)
            ->setReportIDImport($reportIDImport)
            ->setOrdersTable($ordersTable);
    }
    /**
     * Get date value
     * @return string
     */
    public function getDate()
    {
        return $this->date;
    }
    /**
     * Set date value
     * @param string $date
     * @return \StructType\AcceptanceReport
     */
    public function setDate($date = null)
    {
        // validation for constraint: string
        if (!is_null($date) && !is_string($date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($date, true), gettype($date)), __LINE__);
        }
        $this->date = $date;
        return $this;
    }
    /**
     * Get reportIDImport value
     * @return string|null
     */
    public function getReportIDImport()
    {
        return $this->reportIDImport;
    }
    /**
     * Set reportIDImport value
     * @param string $reportIDImport
     * @return \StructType\AcceptanceReport
     */
    public function setReportIDImport($reportIDImport = null)
    {
        // validation for constraint: string
        if (!is_null($reportIDImport) && !is_string($reportIDImport)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reportIDImport, true), gettype($reportIDImport)), __LINE__);
        }
        $this->reportIDImport = $reportIDImport;
        return $this;
    }
    /**
     * Get ordersTable value
     * @return \ArrayType\ArrayOfOrdersTableRow|null
     */
    public function getOrdersTable()
    {
        return $this->ordersTable;
    }
    /**
     * Set ordersTable value
     * @param \ArrayType\ArrayOfOrdersTableRow $ordersTable
     * @return \StructType\AcceptanceReport
     */
    public function setOrdersTable(\ArrayType\ArrayOfOrdersTableRow $ordersTable = null)
    {
        $this->ordersTable = $ordersTable;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AcceptanceReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
